;~ ;*********************************************
		Author		=	Shyangs			;~ ;*****
		Name		=	DelFxExtLocal	;~ ;*****
		ReleaseDate	=	20100511		;~ ;*****
;~ ;*********************************************

#include QA.ahk				; http://www.chocomus.com/qa_en/
#include tf.ahk				; http://www.autohotkey.net/~hugov/tf-lib.htm
#include ZipFolder.ahk		; http://www.autohotkey.com/forum/topic19831.html


;" q}CASw
fQA_RemoveValue(ByRef arr, value){
	index	:=	QA_IndexOf(arr, value)
	if(	0	=	index	){
		Return
	}else{
		QA_Remove(arr, index)
	}
}

;" إ Gui
fCreateGui(){
	global textEditContent, MyProgress, hwnd, Name, ReleaseDate
	str			:=	"椤...C Фűj{ΤzZɮ׾ާ@I"
	Gui, Font, s16
	Gui, -Caption +Border
	Gui, Add, GroupBox, +Center +w600 +h10, %Name%
	Gui, Font, s10
	Gui, Add, Text, +Right +w600, Build/%ReleaseDate% 
	Gui, Add, Text, +Right +w600, Copyright (C) 2010  Shyangs
	Gui, Font, s12
	Gui, Add, Text, +w600, Detail:
	Gui, Add, Edit, +ReadOnly +w600 +r9 vtextEditContent HwndtextEditContentHwnd
	Gui, Add, Progress, +w600 +h20 +cBlue vMyProgress
	Gui, Add, Text, +w600 +cRed, %str%
	Gui, Show
	
	hwnd	:=	textEditContentHwnd
}

;" NBzi׸Ƨs gui P log 
fEditGuiAndFile(textNewContent){
	global pathLogFile, textEditContent, hwnd
	FileAppend, %textNewContent%, %pathLogFile%
	textEditContent	:=	textEditContent . textNewContent
	GuiControl,, textEditContent, %textEditContent%
	ControlSend,, ^{End}, ahk_id %hwnd%		;" ctrl+End bԦ̩ܳ
}

;" }|qsJ}C
fScriptDirPath2Array(ByRef arrSDP){
	Loop, Parse, A_ScriptDir, \
	{
		QA_Push(arrSDP, A_LoopField)
	}
}

;" ˬd{mؿ
fIsInExtensionsDir(ByRef arrSDP){
	lenSDP	:=	QA_Length(arrSDP)
	elmSDP	:=	QA_Get(arrSDP, lenSDP)
	if (	"extensions"	!=	elmSDP	){
		MsgBox,	4096,, " бN{b extensions ؿUI "
		ExitApp
	}
}

;" ˬd Fx O_
fIsFxClosed(ByRef arrSDP){
	lenSDP			:=	QA_Length(arrSDP)
	QA_Remove(arrSDP, lenSDP)
	pathProfile		:=	QA_ToString(arrSDP, "\")
	pathParentLock	:=	pathProfile . "\parent.lock"
	if(	""	!=	FileExist(pathParentLock)	){
		MsgBox,	4096,, "  FirefoxAA楻{I "
		ExitApp
	}
}

;" ˴O_U zipfldr.dll 
fCheck_zipfldrDll(){
	RegRead, regVar, HKEY_CLASSES_ROOT, .ZFSendToTarget
	if("" = regVar){
		MsgBox, "U楻{һݪ zipfldr.dll ɡI"
		ExitApp
	}
}

;" Nɮ/ƧW sJ }C
fFileFolderArray(path, numType, ByRef arr){
	Loop, %path%\*, %numType%
	{
		QA_Push(arr, A_LoopFileName)		
	}
}

;" Odytؿ
fSaveLang(ByRef arrlocalDirName){
	fQA_RemoveValue(arrlocalDirName, "en-US")
	fQA_RemoveValue(arrlocalDirName, "zh-TW")
	fQA_RemoveValue(arrlocalDirName, "zh-CN")
	fQA_RemoveValue(arrlocalDirName, "zh-HK")
}

;" RΤ۪yt
fDelExtLocal(pathLocalDir){
	SetWorkingDir, %pathLocalDir%
	QA_Create(arrlocalDirName)
	fFileFolderArray(pathLocalDir, 2, arrlocalDirName)
	fSaveLang(arrlocalDirName)
	len	:=	QA_Length(arrlocalDirName)
	Loop, %len%
	{
		localDir	:=	QA_Get(arrlocalDirName, A_Index)
		fEditGuiAndFile( "`n`t" . A_Now . ", Ryt " . localDir)
		FileRemoveDir, %localDir%, 1
	}
}

fGetExtLocaDirPath(language){
	strRegex	:=	"locale.*" . language . "\s+([^\s]+)"	;" WF \s ۷ [\f\n\r\t\v]
	strTF		:=	TF_Find("chrome.manifest", "", "", strRegex, 1, 1)
	if(	0	!=	strTF){
		RegExMatch(strTF, strRegex, locaDirPath)
		Return, locaDirPath1		;" locaDirPath }C 1Ӥ
	}else{
		Return, 0
	}
}

fDirLocal(language){
	strPath		:=	fGetExtLocaDirPath(language)
	StringReplace, strPath, strPath, /, \, All			;" ׽uܤϱ׽u
	strRegex	:=	"([^\s]+)\\" . language . "\\"
	RegExMatch(strPath, strRegex, dirLocal)
	Return, dirLocal1
}

;" Y.jar
fUnzipJAR(pathJARDir, jarFileName, zipFileName, pathZipFile, pathUnzDir){
	SetWorkingDir, %pathJARDir%
	fEditGuiAndFile( "`n`t" . A_Now . ", Y " . jarFileName)
	FileMove, %jarFileName%, %zipFileName%
	Unz(pathZipFile, pathUnzDir)
	FileDelete, %zipFileName%
}

;" Y.jar
fZipJAR(pathJARDir, pathUnzDir, jarFileName, zipFileName){
	SetWorkingDir, %pathJARDir%
	fEditGuiAndFile( "`n`t" . A_Now . ", Y " . jarFileName)
	pathZip	:=	pathJARDir . "\" . zipFileName
	QA_Create(arrFileFolderName)
	fFileFolderArray(pathUnzDir, 1, arrFileFolderName)
	lenFFN	:=	QA_Length(arrFileFolderName)
	Loop, %lenFFN%
	{
		elmFFN	:=	QA_Get(arrFileFolderName, A_Index)
		pathFFN	:=	pathUnzDir . "\" . elmFFN
		fEditGuiAndFile( "`n`t" . A_Now . ", Nɮ/Ƨ " . elmFFN . " [JY " . jarFileName)
		Zip(pathFFN, pathZip)
	}
	FileRemoveDir, %pathUnzDir%, 1
	FileMove, %zipFileName%, %jarFileName%
}

fExtLocal(extDirName){
	SetWorkingDir, %extDirName%		;" }u@ؿ ܦUӮMؿ
	pathExtDir	:=	A_WorkingDir
	dirLocal	:=	fDirLocal("en-US")	;" en-US ytɥؿ۹|
	if(	""	!=	dirLocal ){	;" dirLocal sb, i.e.oM󦳻ytɥؿsb
		strRegex	:=	"jar:([^\s]+)\\([^\s]+\.jar)!\\([^\s]+)"
		RegExMatch(dirLocal, strRegex, outputVar)
		jarDir		:=	outputVar1		;" .jarɥؿ
		if(	""	!=	jarDir	)
		{
			pathJARDir	:=	pathExtDir . "\" . jarDir
			jarFileName	:=	outputVar2
			StringReplace, zipFileName, jarFileName, .jar, .zip
			pathZipFile	:=	pathJARDir . "\" . zipFileName
			pathUnzDir	:=	pathJARDir . "\TempFolder_DelFxExtLocal"
			FileCreateDir, %pathUnzDir%
			fUnzipJAR(pathJARDir, jarFileName, zipFileName, pathZipFile, pathUnzDir)
			pathLocalDir:=	pathUnzDir . "\" . outputVar3	
			fDelExtLocal(pathLocalDir)			
			fZipJAR(pathJARDir, pathUnzDir, jarFileName, zipFileName)
		}else{
			pathLocalDir	:=	pathExtDir . "\" . dirLocal
			fDelExtLocal(pathLocalDir)
		}
	}
	SetWorkingDir, %A_ScriptDir%
}

Main(pathLogFile, textEditContent){
	QA_Create(arrSDP)				;" إߤ@Ӱ}C
	fScriptDirPath2Array(arrSDP)	;" }|qsJ}C
	fIsInExtensionsDir(arrSDP)		;" ˬd{mؿ
	fIsFxClosed(arrSDP)				;" ˬd Fx O_
	fCheck_zipfldrDll()				;" ˴O_U zipfldr.dll
	fCreateGui()					;" إ Gui
	;" إ log ɡA OĤ@: {}l椧ɶ
	fEditGuiAndFile( A_Now . ", DelFxExtLocal }lC")
	;" إ߰}CAxsMؿW
	QA_Create(arrExtDirName)
	fFileFolderArray(A_ScriptDir, 2, arrExtDirName)
	lenEDN	:=	QA_Length(arrExtDirName)	;" MؿӼ
	Loop, %lenEDN%
	{
		extDirName	:=	QA_Get(arrExtDirName, A_Index)
		value		:=	A_Index/lenEDN*100	;" iצp
		GuiControl,, MyProgress, %value%	;" siױ
		;" ObBzӮM
		fEditGuiAndFile( "`n`n" . A_Now . ", BzM " . extDirName)
		fExtLocal(extDirName)	;" BzM: Y/Y/R
	}

	fEditGuiAndFile( "`n`n" . A_Now . ", A{C")
	MsgBox, 4096,, "wI"
	ExitApp
}

hwnd			:=	""		;" Ψxs hwnd (Handle of Window)
textEditContent	:=	""		;" Ψxs Gui EditϪe
pathLogFile		:=	A_ScriptDir . "\log_" . A_Now . ".txt"	;" logɸ|

Main(pathLogFile, textEditContent)